Unit AMMDC_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AMMDC(var A :Array of Complex; N :Integer; NLA :Integer;
                NUA :Integer; var B :Array of Complex; NLB :Integer;
                NUB :Integer; var C :Array of Complex);

implementation

procedure AMMDC(var A :Array of Complex; N :Integer; NLA :Integer;
                NUA :Integer; var B :Array of Complex; NLB :Integer;
                NUB :Integer; var C :Array of Complex);
var
I,J,JB,L,IRB,NLAP2,NCA,NCB,NMNUC,NLC,NLCP1,NUC,MM,N1,NX,JI,JBBEG,
   JCBEG,JABEG,IRA,KL :Integer;
SUM :Complex;
const
ZERO :Complex = ( re:0.0; im: 0.0E0 );
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
NLAP2 := NLA+2;
NCA := NLA+NUA+1;
NCB := NUB+NLB+1;
NMNUC := N-NUA;
NLC := Min0(NLB+NLA,N-1);
NLCP1 := NLC+1;
NUC := Min0(NUB+NUA,N-1);
MM := NUC+NLC+1;
N1 := N+1;
if ( NLC <= 0 ) 
 then goto _3;
NX := NLC;
for I:=1 to NLC do
 begin
  for J:=1 to NX do
   begin
    C[(I-1)+(J-1)*N] := ZERO;
_1:
   end;
  NX := NX-1;
_2:
 end;
_3:
if ( NUC <= 0 ) 
 then goto _6;
NX := NLC+2;
for I:=1 to NUC do
 begin
  for J:=NX to MM do
   begin
    JI := N1-I;
    C[(JI-1)+(J-1)*N] := ZERO;
_4:
   end;
  NX := NX+1;
_5:
 end;
_6:
NCB := NUB+NLB+1;
JBBEG := NLC;
JCBEG := NLC+1;
for IRA:=1 to N do
 begin
  for JB:=1 to N do
   begin
    JABEG := NLAP2-IRA;
    IRB := 1;
    JBBEG := NLB+JB;
    KL := Max0(JBBEG-Min0(JBBEG,NCB),1-Min0(1,JABEG));
    JABEG := JABEG+KL;
    JBBEG := JBBEG-KL;
    IRB := IRB+KL;
    if ( JABEG > NCA ) 
     then goto _9;
    if ( IRB < 1 ) 
     then goto _9;
    if ( JBBEG < 1 ) 
     then goto _9;
    SUM := Cmplx(0.0,0.E0);
    for L:=1 to N do
     begin
      SUM := AddC(SUM,MulC(A[(IRA-1)+(JABEG-1)*N],B[(IRB-1)+(JBBEG-1)*N]));
      JABEG := JABEG+1;
      IRB := IRB+1;
      JBBEG := JBBEG-1;
      if ( JABEG > NCA ) 
       then goto _8;
      if ( JBBEG < 1 ) 
       then goto _8;
      if ( IRB > N ) 
       then goto _8;
_7:
     end;
_8:
    C[(IRA-1)+(JCBEG-1)*N] := SUM;
    JCBEG := JCBEG+1;
_9:
   end;
  JCBEG := Max0(NLCP1-IRA,1);
  if ( IRA > NMNUC ) 
   then NCA := NCA-1;
_10:
 end;
end;

end.
